(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['../wrapper', 'should'], factory);
  } else if (typeof exports !== "undefined") {
    factory(require('../wrapper'), require('should'));
  } else {
    var mod = {
      exports: {}
    };
    factory(global.wrapper, global.should);
    global.exactClassNames = mod.exports;
  }
})(this, function (_wrapper, _should) {
  'use strict';

  var _wrapper2 = _interopRequireDefault(_wrapper);

  var _should2 = _interopRequireDefault(_should);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  var Assertion = _should2.default.Assertion;

  Assertion.add('exactClassNames', function (expected) {
    var wrapper = (0, _wrapper2.default)(this.obj),
        actualClasses = wrapper.classNames();

    this.params = {
      actual: wrapper.name(),
      operator: 'to have classNames \'' + expected + '\' but found \'' + actualClasses + '\''
    };

    (0, _should2.default)(expected).be.exactly(actualClasses);
  });
});