(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['../wrapper', 'should'], factory);
  } else if (typeof exports !== "undefined") {
    factory(require('../wrapper'), require('should'));
  } else {
    var mod = {
      exports: {}
    };
    factory(global.wrapper, global.should);
    global.prop = mod.exports;
  }
})(this, function (_wrapper, _should) {
  'use strict';

  var _wrapper2 = _interopRequireDefault(_wrapper);

  var _should2 = _interopRequireDefault(_should);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  var Assertion = _should2.default.Assertion;

  Assertion.add('prop', function (expectedKey, expectedValue) {
    var wrapper = (0, _wrapper2.default)(this.obj),
        wrapperProp = wrapper.prop(expectedKey);

    if (arguments.length > 1 && typeof wrapperProp !== 'undefined') {
      this.params = {
        actual: wrapper.name(),
        operator: 'prop \'' + expectedKey + '\' to have value ' + _should2.default.format(expectedValue) + ', instead found ' + _should2.default.format(wrapperProp)
      };
      (0, _should2.default)(wrapperProp).be.eql(expectedValue, ' ');
    } else {
      this.params = {
        actual: wrapper.name(),
        operator: 'to have prop \'' + expectedKey + '\''
      };
      (0, _should2.default)(wrapperProp).not.be.undefined();
    }
  });
});