(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['./assertion-builder'], factory);
  } else if (typeof exports !== "undefined") {
    factory(require('./assertion-builder'));
  } else {
    var mod = {
      exports: {}
    };
    factory(global.assertionBuilder);
    global.text = mod.exports;
  }
})(this, function (_assertionBuilder) {
  'use strict';

  (0, _assertionBuilder.assertionBuilder)('containsText', function (expected) {
    return this.text().includes(expected);
  }, function (expected) {
    return 'expected \'' + this.name() + '\' to contain text \'' + expected + '\' but found \'' + this.text() + '\'';
  });

  (0, _assertionBuilder.assertionBuilder)('text', function (expected) {
    return String(this.text()) === expected;
  }, function (expected) {
    return 'expected \'' + this.name() + '\' to have exact text of \'' + expected + '\' but found \'' + this.text() + '\'';
  });
});