(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['./assertion-builder'], factory);
  } else if (typeof exports !== "undefined") {
    factory(require('./assertion-builder'));
  } else {
    var mod = {
      exports: {}
    };
    factory(global.assertionBuilder);
    global.value = mod.exports;
  }
})(this, function (_assertionBuilder) {
  'use strict';

  (0, _assertionBuilder.assertionBuilder)('value', function (expected) {
    return String(this.value()) === expected;
  }, function (expected) {
    if (typeof this.value() !== 'undefined') return 'expected \'' + this.name() + '\' to have value \'' + expected + '\' but found \'' + this.value() + '\'';

    return 'element \'' + this.name() + '\' does not have a value';
  });
});