(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['./assertions/attr', './assertions/checked', './assertions/class-name', './assertions/contain', './assertions/data', './assertions/disabled', './assertions/exact-class-names', './assertions/prop', './assertions/props', './assertions/present', './assertions/text', './assertions/state', './assertions/value'], factory);
  } else if (typeof exports !== "undefined") {
    factory(require('./assertions/attr'), require('./assertions/checked'), require('./assertions/class-name'), require('./assertions/contain'), require('./assertions/data'), require('./assertions/disabled'), require('./assertions/exact-class-names'), require('./assertions/prop'), require('./assertions/props'), require('./assertions/present'), require('./assertions/text'), require('./assertions/state'), require('./assertions/value'));
  } else {
    var mod = {
      exports: {}
    };
    factory(global.attr, global.checked, global.className, global.contain, global.data, global.disabled, global.exactClassNames, global.prop, global.props, global.present, global.text, global.state, global.value);
    global.index = mod.exports;
  }
})(this, function () {
  'use strict';
});