(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'enzyme', '../shallow-enzyme', '../react-enzyme', '../static-enzyme'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('enzyme'), require('../shallow-enzyme'), require('../react-enzyme'), require('../static-enzyme'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.enzyme, global.shallowEnzyme, global.reactEnzyme, global.staticEnzyme);
    global.index = mod.exports;
  }
})(this, function (exports, _enzyme, _shallowEnzyme, _reactEnzyme, _staticEnzyme) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = undefined;

  var _shallowEnzyme2 = _interopRequireDefault(_shallowEnzyme);

  var _reactEnzyme2 = _interopRequireDefault(_reactEnzyme);

  var _staticEnzyme2 = _interopRequireDefault(_staticEnzyme);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  function WrapperBuilder(wrapper) {
    if (wrapper instanceof _enzyme.ShallowWrapper) return new _shallowEnzyme2.default(wrapper);

    if (wrapper instanceof _enzyme.ReactWrapper) return new _reactEnzyme2.default(wrapper);

    if (wrapper.cheerio && wrapper.cheerio === '[cheerio object]') {
      return new _staticEnzyme2.default(wrapper);
    }

    throw new Error('Not a recognised Enzyme wrapper.');
  }

  exports.default = WrapperBuilder;
});